using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
namespace ConsoleApplicationTreeDiameter
{
    class Program
    {
        static void Main(string[] args)
        {
            BinTreeNode<int> t1 = BinTreeUtils.BuildRandomTree(3, 1, 30);
		    //BinTreeNodeUtils.ShowTree(t1,"t1");
		    Console.WriteLine(Diameter(t1));
            Console.ReadLine();
        }
        public static BinTreeNode<int> Reconstruct(int[] preorder, int[] inorder)
	    {	
		    Print(preorder,inorder);
		    if(preorder.Length == 1)
		        return(new BinTreeNode<int>(preorder[0]));
		
		    int i=0;
		    while (preorder[0] != inorder[i])
			    i++;
		
		    int[] preorderL = new int [i];
		    int[] inorderL = new int[i];
		    for (int j=0; j<i; j++)
		    {
			    preorderL[j] = preorder[j+1]; 
			    inorderL[j] = inorder[j];
		    }
		    //print(preorderL,inorderL);
		    int[] preorderR = new int [inorder.Length-i-1];
		    int[] inorderR = new int[inorder.Length-i-1];
		    for (int j=i+1; j<inorder.Length; j++)
		    {
			    preorderR[j-i-1] = preorder[j]; 
			    inorderR[j-i-1] = inorder[j];
		    }
		    //print(preorderR,inorderR);
            return (new BinTreeNode<int>(Reconstruct(preorderL, inorderL), preorder[0], Reconstruct(preorderR, inorderR)));	
	    }
	
	    public static void Print(int[] a, int[] b)
	    {
		    for (int i = 0; i < a.Length; i++) 
		    {
			    Console.Write(a[i]+" ");
		    }
            Console.WriteLine();
		    for (int i = 0; i < b.Length; i++) 
		    {
                Console.Write(b[i] + " ");
		    }
            Console.WriteLine();
            Console.WriteLine();
	    }
    	
	    public static int Diameter(BinTreeNode<int> bt)
	    {
		    int treeDiameter = 1;	//      1
		    int h = Height(bt);		//   
    		
		    //     ,        
		    for(int level=1; level<=h; level++)
		    {
			    int n = NumNodesInLevel(bt,level); //    
			    if(n>treeDiameter)
				    treeDiameter = n;
		    }

		    return treeDiameter;
	    } 

	    public static int NumNodesInLevel(BinTreeNode<int> tree, int level)
        {
    	    int sl = 0;
    	    int sr = 0;
        	
    	    if(level==0)
    		    return(1);
    	    if(tree.GetLeft() != null)
    		    sl = NumNodesInLevel(tree.GetLeft(),level-1);
    	    if(tree.GetRight() != null)
    		    sr = NumNodesInLevel(tree.GetRight(),level-1);
    	    return(sl + sr);
        }  
    	
	    public static int Height(BinTreeNode<int> tree)
        {
    	    int hl = 0;
    	    int hr = 0;
        	
    	    if(tree.GetLeft() != null)
    		    hl = 1 + Height(tree.GetLeft());
    	    if(tree.GetRight() != null)
    		    hr = 1 + Height(tree.GetRight());
    	    return(Math.Max(hl,hr));
        }    
    }
}
